Index: main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties	(revision 33280)
+++ main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties	(revision 33281)
@@ -4,118 +4,55 @@
 ##################
 
-help.findinginformationtitle=<h2>How to find information in the {0} collection</h2>
-help.findinginformation=There are {0} ways to find information in this collection:
-help.searchdesc=search for particular words that appear in the text by clicking the Search button
-help.browsedesc=browse documents by <i>{0}</i> by clicking the <i>{0}</i> button
+help.collection_title=Using the {0} collection
+help.collection_general=You can find your way to documents via 'browsing' or 'searching'. Browsing involves navigating through predefined categories and subcategories, or alphabetical lists. Searching will present you with a list of documents containing the specified terms in the specified text/metadata fields.
 
-help.readingdocstitle=<h2>How to read the documents</h2>
-help.readingdocs=<p>You can tell when you have arrived at an individual book or document because its title, \
-or an image of the front cover, appears at the top left of the page. In some collections, a table of contents appears, \
-while in others (eg. when the paged image option is used) just the page number is shown, along with a box that allows you \
-to select a new page and go forward and backward. In the table of contents, the current section heading is in bold face, \
-and the table is expandable -- click on the folders to open or close them; click on the open book at the top to close it.</p>\
-<p>Underneath is the text of the current section. When you have read through it, there are arrows at the \
-bottom to take you on to the next section or back to the previous one.</p>\
-<p>Below the title or front-cover image are some buttons. Click on <i>EXPAND DOCUMENT</i> to expand out the whole text \
-of the current section, or book. If the document is large, this could take a long time and use a lot of memory! \
-Click on <i>EXPAND CONTENTS</i> to expand out the whole table of contents so that you can see the titles of all \
-chapters and subsections. Click on <i>DETACH PAGE</i> to make a new browser window for this document. \
-(This is useful if you want to compare documents, or read two at once.)</p>
+help.browsing_title=Help with Browsing
+help.browsing_general=Browsing is pretty straightforward. Select the appropriate tab underneath the collection header to browse by that metadata field. The browsing structures may be organised alphabetically using horizontal letter classifications, or they may be organised into categories and subcategories.
+help.browsing_bookshelf=This bookshelf icon indicates a new (sub)category of the browsing structure. Clicking on the bookshelf or the {0} icon will open up that part of the browsing structure.
+help.browsing_book=These 'book' icons indicate you have reached a document. Clicking these will take you to an HTML version of the document. Or perhaps a metadata page about the document. {0} indicates a structured document, while {1} indicates a single page document.
+help.browsing_srcicon=These 'source' icons indicate a link to the original version of the document, e.g. PDF, Word, MP3 etc.
+help.icon_bookshelf=bookshelf icon
+help.icon_book=structured document icon
+help.icon_page=single page document icon
+help.icon_plus=plus
+help.icon_pdf=PDF icon
+help.icon_word=Word icon
+help.icon_mp3=MP3 icon
+help.icon_favourites=Favourites icon
+help.icon_berry=Berry icon
+help.icon_
+help.searching_title=Help with Searching
+help.searching_quick=On every page is a quick search form. Enter your search terms, select which index you are searching (if there is a choice) and hit 'search'. Indicate phrases using double quotes around the phrase, e.g. "snail farming". All the default search settings will be used. Results are split into pages - use the next/prev arrows to navigate through the pages of search results.
+help.searching_more=If you want more control over your search settings you can use one of the alternate search forms listed underneath the quick search form.
+help.searching_text=The text search form gives you the same single field search as the quick search form, however you can control more search parameters. These depend on the indexing tool that the collection has been built with, but may include whether you are searching for some or all of the search terms; searching at document or chapter level; casefolding and stemming; which order to sort search results; how many hits per page of search results etc.
 
-help.openbookshelf=Open this bookshelf
-help.sectionarrows=Go to the previous/next section
-
-help.searchingtitle=<h2>How to search for particular words</h2>
-help.searching=<p>From the search page, you make a query in these simple steps:</p>\
-<ol><li>Specify what items you want to search</li>\
-<li>Say whether you want to search for all or just some of the words</li>\
-<li>Type in the words you want to search for</li>\
-<li>Click the <i>Begin Search</i> button</li>\
-</ol>\
-<p>When you make a query, the titles of twenty matching documents will be shown. \
-There is a button at the end to take you on to the next twenty documents.  From \
-there you will find buttons to take you on to the third twenty or back to the \
-first twenty, and so on.  Click the title of any document, or the little button \
-beside it, to see it.</p>\
-<p>A maximum of 50 is imposed on the number of \
-documents returned.  You can change this number by clicking the \
-<i>PREFERENCES</i> button at the top of the page.</p>
-
-help.querytermstitle=<h3>Search Terms</h3>
-help.queryterms=<p>Whatever you type into the query box is interpreted as a list of words or phrases \
-called "search terms."  A term is a single word containing only letters and digits, or a phrase \
-consisting of a sequence of words enclosed in double quotes ("...").  Terms are separated by white spaces. \
-If any other characters such as punctuation appear, they serve to separate terms just as though they were \
-spaces.  And then they are ignored.  You can't search for words that include punctuation.</p> \
-<p>For example, the query</p> \
-<ul><kbd>Agro-forestry in the Pacific Islands: Systems for Sustainability (1993)</kbd></ul> \
-<p>will be treated the same as</p> \
-<ul><kbd>Agro forestry in the Pacific Islands  Systems for Sustainability  1993 </kbd></ul>
-
-help.querytypetitle=<h3>Query type</h3>
-help.querytype=<p>There are two different kinds of query. </p>\
-<ul>\
-<li>Queries for <b>all</b> of the words.  These look for documents (or chapters, or titles) \
-that contain all the words you have specified. Documents that satisfy the query are displayed, in build order. </li>\
-<li>Queries for <b>some</b> of the words.  Just list some terms that are likely to appear in \
-the documents you are looking for.  Documents are displayed in order of how closely they match the query. \
-When determining the degree of match, </li>\
-<ul> \
-<li> the more search term occurrences a document contains, the closer it matches; </li>\
-<li> terms which are rare in the collection as a whole are more important than common ones; </li>\
-<li> short documents match better than long ones. </li>\
-</ul> \
-</ul> \
-<p>Use as many search terms as you like--a whole sentence, or even a whole paragraph.  If you specify only \
-one term, documents will be ordered by its frequency of occurrence.</p>
-
-help.queryscopetitle=<h3>Scope of queries</h3>
-help.queryscope=<p>In most collections you are given a choice of different indexes to search. For example, there might \
-be author or title indexes. Or there might be chapter or paragraph indexes. Generally, \
-the full matching document is returned regardless of which index you search.</p> \
-<p>If documents are books, they will be opened at the appropriate place.</p>
-
-help.changingpreferencestitle=<h2>Changing your preferences</h2>
-help.changingpreferences=<p>When you click the <i>PREFERENCES</i> button at the top of the page you will \
-be able to change some features of the interface to suit your own requirements.</p>
-
-help.collectionpreferencestitle=<h3>Collection preferences</h3>
-help.collectionpreferences=<p>Some collections comprise several subcollections, which can be searched \
-independently or together, as one unit.  If so, you can select which \
-subcollections to include in your searches on the Preferences page. </p>
-
-help.languagepreferencestitle=<h3>Language preferences</h3>
-help.languagepreferences=<p>Each collection has a default presentation language, but you can switch to \
-a different language if you like.  You can also alter the encoding scheme \
-used by Greenstone for output to the browser -- the software chooses \
-sensible defaults, but with some browsers it may be necessary to switch to \
-a different encoding scheme to ensure correct character display. \
-All collections allow you to switch from the standard graphical interface format to a textual one. This \
-is particularly useful for visually impaired users who use large screen fonts or speech synthesizers for output.</p>
-
-help.presentationpreferencestitle=<h3>Presentation preferences</h3>
-help.presentationpreferences=<p>Depending on the particular collection, \
-there may be several options you can set that control the presentation. </p> \
-<p>Collections of Web pages allow you to suppress the Greenstone navigation bar at the top of each document page, \
-so that once you have done a search you land at the exact Web page that matches without any Greenstone header. \
-To do another search you will have to use your browser's "back" button. These collections also allow you to suppress \
-Greenstone's warning message when you click a link that takes you out of the digital library collection and on to the \
-Web itself. And in some Web collections you can control whether the links on the search results page take you straight \
-to the actual URL in question, rather than to the digital library's copy of the page. </p>
-
-help.searchpreferencestitle=<h2>Search preferences</h2>
-help.searchpreferences1=<p>You can switch to an "advanced" query mode which allows you to combine terms \
-using &amp; (for "and"), | (for "or"), and ! (for "not"), using parentheses for \
-grouping if desired. This allows you to specify more precise queries. </p>\
-<p>It is possible to get a large query box, so that you can easily do paragraph-sized searching. \
-It is surprisingly quick to search for large amounts of text. </p>\
-
-help.searchpreferences2=<p>You can turn on the search history feature, which shows you your last few \
-queries.  This makes it easy to repeat slightly modified versions of previous queries.</p> \
-<p>Finally, you can control the number of hits returned, and the \
-number presented on each screenful.</p>
-
-help.mgsearchpreferences=<p>A pair of buttons controls whether upper and lower case must match when searching. \
-For example, if "ignore case differences" is selected, snail farming will be treated the same as Snail Farming and SNAIL FARMING. </p>
+help.searching_form=The form search gives you the ability to search for words in different fields. For example, 'McGowan' in Authors, and 'awesome cats' in Titles. Other search parameters are set across all the search items.
+help.searching_adv=The advanced form search gives you even more precision, allowing boolean combination between terms in different fields. For example, 'McGowan' in Authors AND 'awesome cats' in Titles but NOT "veterinarian" in Fulltext. For collections that allow casefolding and stemming, these options can be set differently for each field of search.
+help.searchparams_title=Search Parameters
+help.searchparams_general=There are lots of search params which you can set on the alternate search forms. (The quick search will use all the default values for these params.) This collection supports the following:
+help.sp_level=Granularity of search, for example looking for the search terms across the entire document or within a section.
+help.sp_matchMode=A 'some' search will return documents that contain one or more of the search terms, while an 'all' search will only return documents that contain all of the search terms.
+help.sp_case=If casefolding is 'on', then ignore case (upper vs lower) distinctions when searching. For example, SNAIL would match snail and Snail. Otherwise, case must match. 
+help.sp_stem=If stemming is 'on', then ignore word endings and match words that have the same root, for example computer would match computing. Otherwise, the entire word must match.
+help.sp_accent=If accentfolding is 'on', then ignore accents when searching. For example, e would match Ãš Ã© etc. Otherwise, each accented form will not match the others.
+help.sp_sortBy=The ordering of search results. By rank, build order or predefined metadata field.
+help.sp_index=This determines the scope of the search - the search might be over the full text, or restricted to metadata elements.
+help.sp_sortOrder=Ascending or descending order based on what is being sorted by. Ascending would be A - Z, 1 - 99, while descending would be Z - A, or 99 - 1.
+help.sp_query=The words or phrase to search for.
+help.sp_maxDocs=How many document results to return.
+help.sp_hitsPerPage=How many hits per page of search results to show.
+help.sp_reverseSort=Return the search results in reverse order.
+help.searchresults_title=Understanding your Search Results
+help.searchresults_general=By default, your search results are presented in order of relevance: those documents more closely matching the search terms are presented first. This can be changed in the search preferences on the alternate search pages.
+help.searchresults_facet_title=Faceted Search
+help.searchresults_facets=This collection supports faceted searching. This means that you can filter your search results by predefined facets.
+help.document_title=Help with Documents
+help.document_general=TODO: general document help
+help.favourites_title=Favourites
+help.favourites=A favourites option is available - this can be switched on in the preferences page if not already on by default. In search results or browsing lists, you can click on the {0} icon by each document to add it to your favourites. The icon will highlight ({1}) to show that the document is in the list. Clicking again will remove it. A small box on the right hand side of the page will give you a link to view your favourites. From there you can delete favourites, view in different formats, and email the list to someone.
+help.berrybasket_title=Berry Baskets
+help.berrybasket=A berry basket (favourites) option is available - this can be switched on in the preferences page if not already on by default. In search results or browsing lists, drag the berries ({0}) of documents you want to save onto the berry basket. From the basket, you can view the list of saved documents, delete them, or email the list to yourself.
+help.rss_title=RSS Feeds
+help.rss=This collection provides an RSS feed. View the RSS page by clicking the {0} button. From here you can subscribe to the feed: then you will be notified if new documents get added to the collection.
 
 #############################