Index: main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl	(revision 33285)
@@ -57,10 +57,10 @@
     <xsl:value-of select="/page/pageRequest/paramList/param[@name='berrybasket']/@value"/>
   </xsl:variable>
-  <xsl:variable name="favouritesbasketswitch">
-    <xsl:value-of select="/page/pageRequest/paramList/param[@name='favouritesbasket']/@value"/>
+  <xsl:variable name="favouritebasketswitch">
+    <xsl:value-of select="/page/pageRequest/paramList/param[@name='favouritebasket']/@value"/>
   </xsl:variable>
   
   <xsl:variable name="berryBasketOn" select="/page/pageRequest/paramList/param[@name='berrybasket' and @value='on']"/>
-  <xsl:variable name="favouritesBasketOn" select="/page/pageRequest/paramList/param[@name='favouritesbasket' and @value='on']"/>
+  <xsl:variable name="favouriteBasketOn" select="/page/pageRequest/paramList/param[@name='favouritebasket' and @value='on']"/>
   <xsl:variable name="documentBasketOn" select="/page/pageRequest/paramList/param[@name='documentbasket' and @value='on']"/>
   
@@ -763,5 +763,5 @@
   -->
   <xsl:template name="gotoFavourites">
-    <xsl:if test="$favouritesBasketOn">
+    <xsl:if test="$favouriteBasketOn">
       <div id="berrybasket" class="hide">
       <img src="interfaces/{$interface_name}/images/{$selected_favourite_icon}" title="click to add to favourites" width="16" height="16" border="0" />
@@ -873,5 +873,5 @@
     <gsf:variable name="unselected_favourite_icon_url">interfaces/<xsl:value-of select="$interface_name"/>/images/<xsl:value-of select="$unselected_favourite_icon"/></gsf:variable>
 
-    <xsl:if test="$favouritesBasketOn">
+    <xsl:if test="$favouriteBasketOn">
       <img src="interfaces/{$interface_name}/images/{$unselected_favourite_icon}" title="click to add to favourites" width="20" height="20" border="0" onclick="toggleFavourite(this)" data-is-favourite="false">
         <xsl:attribute name="id"><xsl:value-of select="/page/pageResponse/collection/@name"/>:<xsl:value-of select="@nodeID"/></xsl:attribute>
@@ -910,5 +910,5 @@
       <xsl:value-of select="/page/pageResponse/document/documentNode[@nodeType='root']/@nodeID"/>
     </xsl:variable>
-    <xsl:if test="$favouritesBasketOn">
+    <xsl:if test="$favouriteBasketOn">
       <div id="documentberries">
         <img id="{/page/pageResponse/collection/@name}:{$rootNode}" src="interfaces/{$interface_name}/images/{$unselected_favourite_icon}" alt="in basket" width="15" height="15" border="0"/>
Index: main/trunk/greenstone3/web/interfaces/default/transform/layouts/toc.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/layouts/toc.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/layouts/toc.xsl	(revision 33285)
@@ -78,5 +78,5 @@
 					        <!-- showing gotoFavourites display-area takes priority over berryBaskets -->
 					        <xsl:choose>
-						  <xsl:when test="/page/pageResponse/interfaceOptions/option[@name = 'favouritesBaskets']/@value = 'true'">
+						  <xsl:when test="/page/pageResponse/interfaceOptions/option[@name = 'favouriteBasket']/@value = 'true'">
 						    <!-- show the goto favourites if it's turned on -->
 						    <xsl:call-template name="gotoFavourites"/>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/berry.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/berry.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/berry.xsl	(revision 33285)
@@ -63,5 +63,5 @@
 		  <!-- showing favourites help text takes priority over berryBasket help text -->
 		  <xsl:choose>
-		    <xsl:when test="/page/pageResponse/interfaceOptions/option[@name = 'favouritesBaskets']/@value = 'true'">
+		    <xsl:when test="/page/pageResponse/interfaceOptions/option[@name = 'favouriteBasket']/@value = 'true'">
 		      <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'favourites.delete_help')"/> <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'favourites.delete_else')"/><xsl:text>  </xsl:text>
 		    </xsl:when>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl	(revision 33285)
@@ -30,5 +30,5 @@
     <script type="text/javascript">$(window).load(openStoredClassifiers);</script>
     <!-- this right sidebar -->
-    <xsl:if test="$berryBasketOn or $favouritesBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
+    <xsl:if test="$berryBasketOn or $favouriteBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
       <div id="rightSidebar">
 	<xsl:if test="$berryBasketOn">
@@ -38,5 +38,5 @@
 	</xsl:if>
 
-	<xsl:if test="$favouritesBasketOn">
+	<xsl:if test="$favouriteBasketOn">
 	  <!-- show the favourites 'basket' if it's turned on -->
 	  <gslib:gotoFavourites/>
@@ -268,8 +268,8 @@
     <!-- The berry/favourite (optional) -->
     <td valign="top">
-      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBaskets']/@value = 'true'">
+      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBasket']/@value = 'true'">
 	<xsl:call-template name="documentBerryForClassifierOrSearchPage"/>
       </xsl:if>
-      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouritesBaskets']/@value = 'true'">
+      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouriteBasket']/@value = 'true'">
 	<xsl:call-template name="documentFavouriteForClassifierOrSearchPage"/>
       </xsl:if>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl	(revision 33285)
@@ -57,9 +57,9 @@
     </xsl:if>
     <xsl:call-template name="documentHelp"/>
-    <xsl:if test="/page/pageResponse/interfaceOptions/option[@name='favouritesBaskets']/@value='true'">
-      <xsl:call-template name="favouritesHelp"/>
+    <xsl:if test="/page/pageResponse/interfaceOptions/option[@name='favouriteBasket']/@value='true'">
+      <xsl:call-template name="favouriteBasketHelp"/>
     </xsl:if>
-    <xsl:if test="/page/pageResponse/interfaceOptions/option[@name='berryBaskets']/@value='true'">
-      <xsl:call-template name="berrybasketsHelp"/>
+    <xsl:if test="/page/pageResponse/interfaceOptions/option[@name='berryBasket']/@value='true'">
+      <xsl:call-template name="berryBasketHelp"/>
     </xsl:if>
     <xsl:if test="//format/gsf:option[@name='RSS']/@value= 'true'">
@@ -138,5 +138,5 @@
     TODO: put some stuff here about icons found on doc pages. toc/paged docs. highlighter, image zoomer, 
   </xsl:template>
-  <xsl:template name="favouritesHelp">
+  <xsl:template name="favouriteBasketHelp">
     <xsl:variable name="fav_icon"><img src="interfaces/{$interface_name}/images/favourite-star-transparent-unselected32.png" width="16" height="16" alt="favourites unselected"/></xsl:variable>
     <xsl:variable name="fav_icon_selected"><img src="interfaces/{$interface_name}/images/favourite-star-transparent-selected32.png" width="16" height="16" alt="favourites selected"/></xsl:variable>
@@ -145,5 +145,5 @@
   </xsl:template>
 
-  <xsl:template name="berrybasketsHelp">
+  <xsl:template name="berryBasketHelp">
     <xsl:variable name="berry_icon"><img src="interfaces/{$interface_name}/images/berry.png" alt="berry icon" width="16" height="16"/></xsl:variable>
     <h3><xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.berrybasket_title')"/></h3><br/>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/pref.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/pref.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/pref.xsl	(revision 33285)
@@ -50,9 +50,9 @@
      <!-- <xsl:call-template name="encoding-param"/>-->
       <xsl:call-template name="format-edit-param"/>
-      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBaskets']/@value = 'true'">
+      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBasket']/@value = 'true'">
 	<xsl:call-template name="berry-basket-param"/>
       </xsl:if>
-      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouritesBaskets']/@value = 'true'">
-	<xsl:call-template name="favourites-basket-param"/>
+      <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouriteBasket']/@value = 'true'">
+	<xsl:call-template name="favourite-basket-param"/>
       </xsl:if>
     <!--<xsl:call-template name="document-maker-param"/> not working at moment-->
@@ -173,14 +173,14 @@
 
 
-<xsl:template name="favourites-basket-param">
-				<div id="favouritesbasketprefs">
-					<xsl:variable name="favouritesbasket"><xsl:choose><xsl:when test="/page/pageRequest/paramList/param[@name='favouritesbasket']"><xsl:value-of select="/page/pageRequest/paramList/param[@name='favouritesbasket']/@value"/></xsl:when><xsl:otherwise>off</xsl:otherwise></xsl:choose></xsl:variable>
+<xsl:template name="favourite-basket-param">
+				<div id="favouritebasketprefs">
+					<xsl:variable name="favouritebasket"><xsl:choose><xsl:when test="/page/pageRequest/paramList/param[@name='favouritebasket']"><xsl:value-of select="/page/pageRequest/paramList/param[@name='favouritebasket']/@value"/></xsl:when><xsl:otherwise>off</xsl:otherwise></xsl:choose></xsl:variable>
 					<div class="paramLabel">
-						<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.favouritesbasket')"/>
-					</div>
-					<div class="paramValue">
-						<select name="favouritesbasket">
-							<option value="on"><xsl:if test="$favouritesbasket='on'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.on')"/></option> 
-							<option value="off"><xsl:if test="$favouritesbasket='off'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.off')"/></option>
+						<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.favouritebasket')"/>
+					</div>
+					<div class="paramValue">
+						<select name="favouritebasket">
+							<option value="on"><xsl:if test="$favouritebasket='on'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.on')"/></option> 
+							<option value="off"><xsl:if test="$favouritebasket='off'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'pref.off')"/></option>
 						</select>
 					</div>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/query.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/query.xsl	(revision 33284)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/query.xsl	(revision 33285)
@@ -59,5 +59,5 @@
 
 	<xsl:template name="displayBaskets">
-	  <xsl:if test="$berryBasketOn or $favouritesBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
+	  <xsl:if test="$berryBasketOn or $favouriteBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
 	    <div id="rightSidebar">
 	      <xsl:if test="$berryBasketOn">
@@ -67,5 +67,5 @@
 	      </xsl:if>
 
-	      <xsl:if test="$favouritesBasketOn">
+	      <xsl:if test="$favouriteBasketOn">
 		<!-- show the favourites 'basket' if it's turned on -->
 		<gslib:gotoFavourites/>
@@ -95,8 +95,8 @@
 						<!-- The berry/favourite (optional) -->
 						<td valign="top">
-						  <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBaskets']/@value = 'true'">
+						  <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'berryBasket']/@value = 'true'">
 						    <xsl:call-template name="documentBerryForClassifierOrSearchPage"/>
 						  </xsl:if>
-						  <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouritesBaskets']/@value = 'true'">
+						  <xsl:if test="/page/pageResponse/interfaceOptions/option[@name = 'favouriteBasket']/@value = 'true'">
 						    <xsl:call-template name="documentFavouriteForClassifierOrSearchPage"/>
 						  </xsl:if>