Index: other-projects/is-sheet-music-encore/trunk/image-identification-development/.idea/workspace.xml
===================================================================
--- other-projects/is-sheet-music-encore/trunk/image-identification-development/.idea/workspace.xml	(revision 33243)
+++ other-projects/is-sheet-music-encore/trunk/image-identification-development/.idea/workspace.xml	(revision 33304)
@@ -20,8 +20,16 @@
         <entry file="file://$PROJECT_DIR$/src/Main.java">
           <provider selected="true" editor-type-id="text-editor">
-            <state relative-caret-position="-810">
-              <caret line="126" column="37" lean-forward="true" selection-start-line="126" selection-start-column="37" selection-end-line="126" selection-end-column="37" />
+            <state relative-caret-position="801">
+              <caret line="326" selection-start-line="326" selection-end-line="326" />
               <folding>
                 <element signature="imports" expanded="true" />
+                <element signature="class#StartAndEndPoint#0;class#Main#0" />
+                <element signature="method#removeDuplicates#0;class#Main#0" />
+                <element signature="method#StandardDeviation#0;class#Main#0" />
+                <element signature="method#toBufferedImage#0;class#Main#0" />
+                <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+                <element signature="method#ClassifierLineCount#0;class#Main#0" />
+                <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+                <element signature="e#7430#7439#0" expanded="true" />
               </folding>
             </state>
@@ -34,4 +42,5 @@
     <findStrings>
       <find>aeu.ark+=13960=t93787r1w-10.png</find>
+      <find>returnArray</find>
     </findStrings>
   </component>
@@ -44,5 +53,5 @@
   </component>
   <component name="ProjectFrameBounds" extendedState="6">
-    <option name="x" value="992" />
+    <option name="x" value="65" />
     <option name="y" value="24" />
     <option name="width" value="928" />
@@ -133,9 +142,7 @@
   <component name="ToolWindowManager">
     <frame x="65" y="24" width="1855" height="1056" extended-state="6" />
-    <editor active="true" />
     <layout>
       <window_info anchor="right" id="Palette" order="4" />
       <window_info anchor="bottom" id="TODO" order="10" />
-      <window_info anchor="bottom" id="Messages" order="3" weight="0.32842106" />
       <window_info anchor="right" id="Palette&#9;" order="1" />
       <window_info id="Image Layers" order="4" />
@@ -143,6 +150,6 @@
       <window_info anchor="bottom" id="Event Log" order="1" side_tool="true" />
       <window_info anchor="right" id="Maven Projects" order="3" />
-      <window_info active="true" anchor="bottom" id="Run" order="6" visible="true" weight="0.21881391" />
       <window_info anchor="bottom" id="Version Control" order="2" />
+      <window_info anchor="bottom" id="Run" order="6" weight="0.22392638" />
       <window_info anchor="bottom" id="Terminal" order="0" weight="0.42638037" />
       <window_info id="Capture Tool" order="2" />
@@ -153,6 +160,6 @@
       <window_info id="UI Designer" order="1" />
       <window_info anchor="right" id="Theme Preview" order="2" />
+      <window_info id="Favorites" order="3" side_tool="true" />
       <window_info anchor="bottom" id="Debug" order="7" weight="0.39894736" />
-      <window_info id="Favorites" order="3" side_tool="true" />
       <window_info anchor="right" content_ui="combo" id="Hierarchy" order="7" weight="0.25" />
       <window_info anchor="bottom" id="Inspection" order="9" weight="0.4" />
@@ -162,4 +169,5 @@
       <window_info anchor="bottom" id="Cvs" order="8" weight="0.25" />
       <window_info anchor="bottom" id="Find" order="5" weight="0.32924336" />
+      <window_info anchor="bottom" id="Messages" order="3" weight="0.32822084" />
     </layout>
     <layout-to-restore>
@@ -197,8 +205,116 @@
   <component name="XDebuggerManager">
     <breakpoint-manager>
-      <option name="time" value="3" />
+      <option name="time" value="4" />
     </breakpoint-manager>
   </component>
   <component name="editorHistoryManager">
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="4770">
+          <caret line="318" column="55" selection-start-line="318" selection-start-column="55" selection-end-line="318" selection-end-column="55" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="3600">
+          <caret line="240" selection-start-line="240" selection-end-line="240" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="2730">
+          <caret line="182" column="44" lean-forward="true" selection-start-line="182" selection-start-column="44" selection-end-line="182" selection-end-column="44" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="2130">
+          <caret line="142" column="30" selection-start-line="142" selection-start-column="30" selection-end-line="142" selection-end-column="30" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="2025">
+          <caret line="135" column="56" lean-forward="true" selection-start-line="135" selection-start-column="56" selection-end-line="135" selection-end-column="56" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="1890">
+          <caret line="126" column="37" lean-forward="true" selection-start-line="126" selection-start-column="37" selection-end-line="126" selection-end-column="37" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
     <entry file="file://$PROJECT_DIR$/src/Main.java">
       <provider selected="true" editor-type-id="text-editor">
@@ -207,4 +323,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -217,4 +341,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -227,4 +359,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -237,4 +377,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -247,4 +395,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -257,4 +413,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -267,4 +431,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -277,4 +449,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -287,4 +467,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -297,4 +485,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -307,4 +503,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -317,4 +521,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -327,4 +539,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -337,4 +557,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -347,4 +575,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -357,4 +593,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -367,4 +611,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -377,4 +629,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -387,4 +647,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -397,4 +665,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -407,4 +683,12 @@
           <folding>
             <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>
@@ -418,10 +702,29 @@
       </provider>
     </entry>
-    <entry file="file://$PROJECT_DIR$/src/Main.java">
-      <provider selected="true" editor-type-id="text-editor">
-        <state relative-caret-position="-810">
-          <caret line="126" column="37" lean-forward="true" selection-start-line="126" selection-start-column="37" selection-end-line="126" selection-end-column="37" />
-          <folding>
-            <element signature="imports" expanded="true" />
+    <entry file="jar:///usr/lib/jvm/java-8-oracle/src.zip!/java/lang/Object.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="238">
+          <caret line="234" column="18" selection-start-line="234" selection-start-column="18" selection-end-line="234" selection-end-column="18" />
+          <folding>
+            <element signature="e#10065#10066#0" expanded="true" />
+            <element signature="e#10148#10149#0" expanded="true" />
+          </folding>
+        </state>
+      </provider>
+    </entry>
+    <entry file="file://$PROJECT_DIR$/src/Main.java">
+      <provider selected="true" editor-type-id="text-editor">
+        <state relative-caret-position="801">
+          <caret line="326" selection-start-line="326" selection-end-line="326" />
+          <folding>
+            <element signature="imports" expanded="true" />
+            <element signature="class#StartAndEndPoint#0;class#Main#0" />
+            <element signature="method#removeDuplicates#0;class#Main#0" />
+            <element signature="method#StandardDeviation#0;class#Main#0" />
+            <element signature="method#toBufferedImage#0;class#Main#0" />
+            <element signature="method#ClassifierPixelCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineCount#0;class#Main#0" />
+            <element signature="method#ClassifierLineClusterOLD#0;class#Main#0" />
+            <element signature="e#7430#7439#0" expanded="true" />
           </folding>
         </state>